//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D404A02005D.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D404A02005D.cm

//## begin module%3D404A02005D.cp preserve=no
//## end module%3D404A02005D.cp

//## Module: TableModParam%3D404A02005D; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/TableModParam.h

#ifndef TABLEMODPARAM_H
#define TABLEMODPARAM_H 1

//## begin module%3D404A02005D.additionalIncludes preserve=no
//## end module%3D404A02005D.additionalIncludes

//## begin module%3D404A02005D.includes preserve=yes
//## end module%3D404A02005D.includes

// xsTypes
#include <main/xsTypes.h>
// ModParam
#include <XSModel/Parameter/ModParam.h>
//## begin module%3D404A02005D.declarations preserve=no
//## end module%3D404A02005D.declarations

//## begin module%3D404A02005D.additionalDeclarations preserve=yes
//## end module%3D404A02005D.additionalDeclarations


//## begin TableModParam%36C47EBDB700.preface preserve=yes
//## end TableModParam%36C47EBDB700.preface

//## Class: TableModParam%36C47EBDB700
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3804B679FB3A;protected: ParamData { -> }

class TableModParam : public ModParam  //## Inherits: <unnamed>%37179FA02BC0
{
  //## begin TableModParam%36C47EBDB700.initialDeclarations preserve=yes
  //## end TableModParam%36C47EBDB700.initialDeclarations

  public:
    //## Constructors (generated)
      TableModParam(const TableModParam &right);

    //## Constructors (specified)
      //## Operation: TableModParam%383031EC6CC8
      TableModParam (const string& inputName, ComponentBase* p, Real val, Real delta = 0., Real high = LARGE, Real low = -LARGE, Real top = LARGE, Real bot = -LARGE, const string& unit = "");

    //## Destructor (generated)
      virtual ~TableModParam();


    //## Other Operations (specified)
      //## Operation: clone%3773E3982468; C++
      virtual TableModParam* clone (ComponentBase* p) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: logInterp%373B0D2995A2
      //	The value of the Method Keyword in the Table model file.
      //	logInterp = 0 -> linear interpolation as opposed to
      //	logarithmic (the specifics of "linear" interpolation are
      //	not clear -- could this mean any technique in which the
      //	abscissa is linear rather than logarithmic?)
      const bool logInterp () const;
      void logInterp (bool value);

      //## Attribute: numVals%373B0D2995A3
      const int numVals () const;
      void numVals (int value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Parameter::Tabulated Values%3D6D05EF015C
      //## Role: TableModParam::tabValue%3D6D05F00041
      //## Qualifier: index%3D6D0608032F; size_t
      const RealArray& tabValue () const;
      void setTabValue (const RealArray& value);
      Real tabValue (size_t index) const;
      void tabValue (size_t index, Real value);

    // Additional Public Declarations
      //## begin TableModParam%36C47EBDB700.public preserve=yes
      //## end TableModParam%36C47EBDB700.public

  protected:

    //## Other Operations (specified)
      //## Operation: compare%3773EC517828; C++
      //	Additional Protected Declarations
      virtual bool compare (const Parameter& right) const;

    // Additional Protected Declarations
      //## begin TableModParam%36C47EBDB700.protected preserve=yes
      //## end TableModParam%36C47EBDB700.protected

  private:
    //## Constructors (generated)
      TableModParam();

    //## Assignment Operation (generated)
      TableModParam & operator=(const TableModParam &right);

    // Additional Private Declarations
      //## begin TableModParam%36C47EBDB700.private preserve=yes
      //## end TableModParam%36C47EBDB700.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin TableModParam::logInterp%373B0D2995A2.attr preserve=no  public: bool {U} false
      bool m_logInterp;
      //## end TableModParam::logInterp%373B0D2995A2.attr

      //## begin TableModParam::numVals%373B0D2995A3.attr preserve=no  public: int {U} 0
      int m_numVals;
      //## end TableModParam::numVals%373B0D2995A3.attr

    // Data Members for Associations

      //## Association: XSModel::Parameter::Tabulated Values%3D6D05EF015C
      //## begin TableModParam::tabValue%3D6D05F00041.role preserve=no  public: RealArray { -> 1..nVHgN}
      RealArray m_tabValue;
      //## end TableModParam::tabValue%3D6D05F00041.role

    // Additional Implementation Declarations
      //## begin TableModParam%36C47EBDB700.implementation preserve=yes
      //## end TableModParam%36C47EBDB700.implementation

};

//## begin TableModParam%36C47EBDB700.postscript preserve=yes
//## end TableModParam%36C47EBDB700.postscript

// Class TableModParam 

//## Get and Set Operations for Class Attributes (inline)

inline const bool TableModParam::logInterp () const
{
  //## begin TableModParam::logInterp%373B0D2995A2.get preserve=no
  return m_logInterp;
  //## end TableModParam::logInterp%373B0D2995A2.get
}

inline void TableModParam::logInterp (bool value)
{
  //## begin TableModParam::logInterp%373B0D2995A2.set preserve=no
  m_logInterp = value;
  //## end TableModParam::logInterp%373B0D2995A2.set
}

inline const int TableModParam::numVals () const
{
  //## begin TableModParam::numVals%373B0D2995A3.get preserve=no
  return m_numVals;
  //## end TableModParam::numVals%373B0D2995A3.get
}

inline void TableModParam::numVals (int value)
{
  //## begin TableModParam::numVals%373B0D2995A3.set preserve=no
  m_numVals = value;
  //## end TableModParam::numVals%373B0D2995A3.set
}

//## Get and Set Operations for Associations (inline)

inline const RealArray& TableModParam::tabValue () const
{
  //## begin TableModParam::tabValue%3D6D05F00041.get preserve=no
  return m_tabValue;
  //## end TableModParam::tabValue%3D6D05F00041.get
}

inline void TableModParam::setTabValue (const RealArray& value)
{
  //## begin TableModParam::setTabValue%3D6D05F00041.set preserve=yes
  m_tabValue.resize(value.size());
  m_tabValue = value;
  //## end TableModParam::setTabValue%3D6D05F00041.set
}

inline Real TableModParam::tabValue (size_t index) const
{
  //## begin TableModParam::tabValue%3D6D05F00041.qualget preserve=no
  return m_tabValue[index];
  //## end TableModParam::tabValue%3D6D05F00041.qualget
}

inline void TableModParam::tabValue (size_t index, Real value)
{
  //## begin TableModParam::tabValue%3D6D05F00041.qualset preserve=no
  m_tabValue[index] = value;
  //## end TableModParam::tabValue%3D6D05F00041.qualset
}

//## begin module%3D404A02005D.epilog preserve=yes
//## end module%3D404A02005D.epilog


#endif
